import { useState } from 'react';
import PropTypes from 'prop-types';
import AtomButton, {
// atomButtonDesigns,
atomButtonShapes, atomButtonSizes } from '@s-ui/react-atom-button';
import { BASE_CLASS } from '../../config.js';
import useDomain from '../../hooks/useDomain.js';
import useGetCurrentToken from '../../hooks/useGetCurrentToken.js';
import useI18n from '../../hooks/useI18n.js';
import Notification from '../Info/Notification.js';
import LoginButton from '../Input/LoginButton.js';
import PasswordInputField from '../Input/PasswordInputField.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var PasswordChangeForm = function PasswordChangeForm(_ref) {
  var icons = _ref.icons;
  var i18n = useI18n();
  var domain = useDomain();
  var _useGetCurrentToken = useGetCurrentToken(),
    getCurrentToken = _useGetCurrentToken.getCurrentToken;
  var _getCurrentToken = getCurrentToken(),
    token = _getCurrentToken.token;
  var _useState = useState(''),
    newPassword = _useState[0],
    setNewPassword = _useState[1];
  var _useState2 = useState(''),
    repeatPassword = _useState2[0],
    setRepeatPassword = _useState2[1];
  var _useState3 = useState({
      text: '',
      isError: false
    }),
    notificationState = _useState3[0],
    setNotificationState = _useState3[1];
  var handleChange = function handleChange(e) {
    var _e$target = e == null ? void 0 : e.target,
      value = _e$target.value;
    setNewPassword(value);
  };
  var handleChangeRepeat = function handleChangeRepeat(e) {
    var _e$target2 = e == null ? void 0 : e.target,
      value = _e$target2.value;
    setRepeatPassword(value);
  };
  var handleSubmit = function handleSubmit() {
    domain.get('change_password_use_case').execute({
      password: newPassword,
      token: token
    }).then(function (_ref2) {
      var error = _ref2[0];
      if (error) {
        setNotificationState({
          text: i18n.t('LOGIN_CROSS.PASSWORD_RESET.STEP_2.ERRORS.SERVER_ERROR'),
          isError: true
        });
        return;
      }
      setNotificationState({
        text: i18n.t('LOGIN_CROSS.PASSWORD_RESET.STEP_2.SUCCESS.PASSWORD_CHANGED'),
        isError: false
      });
    });
  };
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [notificationState.text ? /*#__PURE__*/_jsxs(_Fragment, {
      children: [/*#__PURE__*/_jsx(Notification, {
        notificationText: notificationState.text,
        isError: notificationState.isError
      }), /*#__PURE__*/_jsx("div", {
        className: BASE_CLASS + "-formButtons",
        children: /*#__PURE__*/_jsx("div", {
          className: BASE_CLASS + "-formButton",
          children: /*#__PURE__*/_jsx(LoginButton, {})
        })
      })]
    }) : null, !notificationState.text ? /*#__PURE__*/_jsxs(_Fragment, {
      children: [/*#__PURE__*/_jsx("div", {
        className: BASE_CLASS + "-formInput",
        children: /*#__PURE__*/_jsx(PasswordInputField
        // errorText={errorText}
        , {
          id: "new_password",
          label: i18n.t('LOGIN_CROSS.PASSWORD_RESET.STEP_2.NEW_PASSWORD_LABEL'),
          name: "new_password",
          onChange: handleChange,
          placeholder: i18n.t('LOGIN_CROSS.PASSWORD_RESET.STEP_2.PLACEHOLDER'),
          value: newPassword,
          icons: icons
        })
      }), /*#__PURE__*/_jsx("div", {
        className: BASE_CLASS + "-formInput",
        children: /*#__PURE__*/_jsx(PasswordInputField
        // errorText={errorText}
        , {
          id: "repeat_password",
          label: i18n.t('LOGIN_CROSS.PASSWORD_RESET.STEP_2.REPEAT_PASSWORD_LABEL'),
          name: "repeat_password",
          onChange: handleChangeRepeat,
          placeholder: i18n.t('LOGIN_CROSS.PASSWORD_RESET.STEP_2.PLACEHOLDER'),
          value: repeatPassword,
          icons: icons
        })
      }), /*#__PURE__*/_jsx("div", {
        className: BASE_CLASS + "-formButtons",
        children: /*#__PURE__*/_jsx("div", {
          className: BASE_CLASS + "-formButton",
          children: /*#__PURE__*/_jsx(AtomButton
          // disabled={}  // TODO
          , {
            fullWidth: true
            // isLoading={isLoading}  // TODO
            ,
            onClick: handleSubmit,
            shape: atomButtonShapes.CIRCULAR,
            size: atomButtonSizes.LARGE,
            children: i18n.t('LOGIN_CROSS.PASSWORD_RESET.STEP_2.SUBMIT_BUTTON')
          })
        })
      })]
    }) : null]
  });
};
PasswordChangeForm.displayName = 'PasswordChangeForm';
export default PasswordChangeForm;